package uebung06;

import javafx.scene.Parent;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.GridPane;
import javafx.scene.text.Text;

/**
 * 
 * @author Lorenz Schauer
 * 
 * Die Anzeige muss bei Änderung der Property-Werte automatisch Ihre Textfelder ändern. Das geschieht mittels ChangeListener
 *
 */
public class Anzeige extends Parent {
	
	private Text balance_info, interest_info;
	
	public Anzeige(Bank bank){
		
		BorderPane root = new BorderPane();
		
		Text header = new Text("Willkommen bei Ihrer Bank!");
		
		root.setTop(header);
		
		header.setId("header");
		
		GridPane gp = new GridPane();
		root.setCenter(gp);
		
		Label c_label = new Label("Ihr Kontostand: ");
		balance_info = new Text(""+bank.getBalance());
		
		Label int_label = new Label("Ihre Zinsen: ");
		interest_info = new Text(""+bank.getInterest());
		
		TextField tf_einzahlen, tf_auszahlen;
		
		tf_einzahlen = new TextField();
		tf_auszahlen = new TextField();
		
		Button btn_einzahlen = new Button("einzahlen");
		Button btn_auszahlen = new Button("auszahlen");
		
		btn_einzahlen.setOnAction(e -> {
			
			bank.einzahlen(Double.parseDouble(tf_einzahlen.getText()));
			tf_einzahlen.setText("");
		});
		
		btn_auszahlen.setOnAction(e -> {
			
			bank.auszahlen(Double.parseDouble(tf_auszahlen.getText()));
			tf_auszahlen.setText("");
		});
		
		gp.add(c_label, 0, 0);
		gp.add(balance_info, 1, 0);
		
		gp.add(int_label, 0, 1);
		gp.add(interest_info, 1, 1);
		
		gp.add(tf_einzahlen, 0, 2);
		gp.add(tf_auszahlen, 1, 2);
		
		gp.add(btn_einzahlen, 0, 3);
		gp.add(btn_auszahlen, 1, 3);
		
		this.getChildren().add(root);

		
		// Update-Methode über ChangeListener. Implementiert als Lambda-Ausdruck:
		
		bank.balanceProperty().addListener((obs,old,newV)->{
			this.balance_info.setText(""+newV);
		});
		
		bank.interestProperty().addListener((obs,old,newV)->{
			this.interest_info.setText(""+newV);
		});
		
	}

	
	
	
}
